﻿
using System;
using System.Windows;
using System.Windows.Forms;
using System.Collections;
using System.Collections.Generic;

namespace VZInterfaceTestHandbook
{
  /**
   * Block commands
   */
  public partial class BlockCommands
  {
    private IComIf comIf;

    /**
     * @param com: uses Interface IComIf
     */
    public BlockCommands(IComIf com)
    {
      comIf = com;
    }

    /**
     * Flags and Units block command
     * @return info array
     */
    //@@@START_FLAGSANDUNITS2@@@
    public Byte[] FlagsAndUnits2()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Boolean iReturn;
      /*Declaration*/
      Byte[] bufSnd = new Byte[4];
      Byte[] bufRecv = new Byte[128 + 4]; //header,cmd,len,blk,128 data

      /*Assignment*/
      bufSnd[0] = 0x00;
      bufSnd[1] = 0x10;
      bufSnd[2] = 0x01;
      bufSnd[3] = 0x0B; //block number

      /*Send command*/
      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return null;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return null;
        }
        else
          return bufRecv;
      }
    }
    //@@@STOP_FLAGSANDUNITS2@@@

    /**
     * Ethernet block command
     * @return info array
     */
    //@@@START_ETHERNET2@@@
    public Byte[] Ethernet2()
    {
      Wolfprot2 wp2 = new Wolfprot2(comIf);
      Boolean iReturn;
      /*Declaration*/
      Byte[] bufSnd = new Byte[4];
      Byte[] bufRecv = new Byte[128 + 4]; //header,cmd,len,blk,128 data

      /*Assignment*/
      bufSnd[0] = 0x00;
      bufSnd[1] = 0x10;
      bufSnd[2] = 0x01;
      bufSnd[3] = 0x0C;

      /*Send command*/
      iReturn = wp2.execCmd(bufSnd, ref bufRecv);
      if (iReturn == true)
      {
        MessageBox.Show("No communication!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return null;
      }
      else
      {
        if ((bufRecv[0] & 0x80) == 0x80)
        {
          wp2.ErrorSummary(bufRecv[2]);
          return null;
        }
        else
          return bufRecv;
      }
    }
    //@@@STOP_ETHERNET2@@@
  }
}
