﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Net;
using System.Threading;



namespace VZInterfaceTestHandbook
{
  class Devices
  {
    IComIf comIf;

    /**
     * @param com: uses Interface IComIf
     */
    public Devices(IComIf com)
    {
      comIf = com;
    }

    /**
     * @return string array with discovery information
     */
    //@@@START_SCANDEVICES@@@
    public string[] ScanDevices()
    {
      // Define the default port
      int defaultPort = 50913;
      // Create the string to send
      string strRequest = "req_vz_list";

      // Get the host name
      string hostName = Dns.GetHostName();

      // Get the current ip address
      IPAddress[] localAddressArray = Dns.GetHostAddresses(hostName);

      // localAddress array contains the IP of IPV6 and IPV4
      // the desired protocol has to be choosen
      IPAddress localAddress = IPAddress.Any;
      bool ipv4 = false;
      int x = 0;
      while (!ipv4)
      {
        // Split address into a string array
        // the string array is longer than 1 byte, if the address is the wanted one
        // split with the char "." for IPv4 and ":" for IPv6)
        string[] stringlocalAdress = localAddressArray[x].ToString().Split('.');
        if (stringlocalAdress.Length > 1)
        {
          localAddress = localAddressArray[x];
          ipv4 = true;
        }
        x++;
      }

      // Create a new socket
      Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Dgram,
                                  ProtocolType.Udp);

      // Bind the socket to default IP address and port.
      socket.Bind(new IPEndPoint(localAddress, defaultPort));

      // Set the receive timeout
      socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReceiveTimeout, 5);

      // Set socketoption for broadcast
      socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);

      // Create a broadcast
      IPAddress ipaddr = IPAddress.Broadcast;

      // Send the broadcast into network
      socket.SendTo(ASCIIEncoding.ASCII.GetBytes(strRequest), new IPEndPoint(ipaddr, defaultPort));

      Byte[] buf = new Byte[1000];

      // Get all devices
      string[] receivedBuf = new string[100];
      // A counter for the value of devices
      int count = 0;
      bool continueReceive = true;
      do
      {
        // Try to get a device, goes to catch if got none
        try
        {
          // Receive a device
          socket.Receive(buf);

          // enable to check if the reply packet is ok
          Byte[] byteBackup = new Byte[12];
          for (int i = 0; i < byteBackup.Length; i++)
          {
            byteBackup[i] = buf[i];
          }
          string stringBackup = Encoding.ASCII.GetString(byteBackup);
          // Safetyquery to be sure that the a visualizer
          // answers to the broadcast
          if (stringBackup == strRequest && buf.Length >= byteBackup.Length)
          {
            // Convert the byte array into a string
            receivedBuf[count] = System.Text.Encoding.ASCII.GetString(buf);
            // Clear: the byte array buf
            for (int i = 0; i < buf.Length; i++)
            {
              buf[i] = 0;
            }

            // Increment integer for the next device, a max number of devices of 100 is assumed
            count++;
            if (count >= receivedBuf.Length)
            {
              continueReceive = false;
              MessageBox.Show("Reached maximal count of devices", "Attention",
                              MessageBoxButtons.OK);
            }
          }
        }
        catch
        { continueReceive = false; }
      }
      while (continueReceive);

      string[] receivedDevices = new string[count];
      for (int j = 0; j < receivedDevices.Length; j++)
      {
        string[] splittedRecvBuf = receivedBuf[j].Split('?');
        receivedDevices[j] = splittedRecvBuf[1];
      }

      // Close the socket
      socket.Close();
      return receivedDevices;
    }
    //@@@STOP_SCANDEVICES@@@
  }
}
