﻿
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace VZInterfaceTestHandbook
{
  public partial class FormXMLFile : Form
  {
    IComIf comIf;
    Boolean isConnected = false;

    /**
     * @param com: uses Interface IComIf
     */
    public FormXMLFile(IComIf com)
    {
      comIf = com;
      InitializeComponent();
    }

    /**
     * Open connection
     * @return success = false
     */
    private Boolean connOpen()
    {
      if (comIf.Open())
      {
        MessageBox.Show("Couldn´t open interface!", "Error",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
        return true;
      }
      isConnected = true;
      return false;
    }

    /**
     * Close connection
     */
    private void connClose()
    {
      if (isConnected)
        comIf.Close();
      isConnected = false;
    }
    private void buttonReturn_Click(object sender, EventArgs e)
    {
      Close();
    }

    private void buttonXMLFile_Click(object sender, EventArgs e)
    {
      // Create a browser dialog
      FolderBrowserDialog objDialog = new FolderBrowserDialog();
      // Description
      objDialog.Description = "Save File";
      // First selected path to save
      objDialog.SelectedPath = @"C:\";
      DialogResult objResult = objDialog.ShowDialog(this);
      if (objResult == DialogResult.OK)
      {
        XMLFile xmlFile = new XMLFile(comIf);
        /*Open interface*/
        if (connOpen())
          return;
        /*Send command*/
        xmlFile.readXMLFile(objDialog.SelectedPath);
        /*Close interface*/
        connClose();
        MessageBox.Show("Saved XML file successfully");
      }
      else
        MessageBox.Show("Error saving file!");
    }
  }
}
